﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HelloUnity.Objects;
using HelloUnity.IoC;
using HelloUnity.Unity;

namespace HelloUnity
{
    class Program
    {
        static void Main(string[] args)
        {
            Bootstrapper.Run();
            #region
            IEnumerable<IAnimal> animalList = IoCHelper.ResolveAll<IAnimal>();
            foreach (var animal in animalList)
            {
                animal.Shout();
            }

            IEnumerable<IPeople> peopleList = IoCHelper.ResolveAll<IPeople>();
            foreach (var people in peopleList)
            {
                people.Speak();
            }
            #endregion
            IAnimal cat = IoCHelper.Resolve<IAnimal>("cat");
            cat.Shout();
            IPeople male = IoCHelper.Resolve<IPeople>("male");
            male.Speak();
            Console.Read();
        }
    }
}
